/*********
  Complete project details at http://randomnerdtutorials.com
*********/

#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

Adafruit_SSD1306 display(128, 64, &Wire, 4);
/*#include <SPI.h>
  #define BME_SCK 18
  #define BME_MISO 19
  #define BME_MOSI 23
  #define BME_CS 5*/

#define SEALEVELPRESSURE_HPA (1013.25)

Adafruit_BME280 bme; // I2C
//Adafruit_BME280 bme(BME_CS); // hardware SPI
//Adafruit_BME280 bme(BME_CS, BME_MOSI, BME_MISO, BME_SCK); // software SPI

unsigned long delayTime;

void setup() {
  Serial.begin(115200);
  Wire.begin(27, 22);
  Serial.println(F("BME280 test"));

  if (!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) {
    while (true);
  }
  display.display();
  display.clearDisplay();


  bool status;

  // default settings
  // (you can also pass in a Wire library object like &Wire2)
  status = bme.begin(0x76);
  if (!status) {
    Serial.println("Could not find a valid BME280 sensor, check wiring!");
    while (1);
  }

  Serial.println("-- Default Test --");
  delayTime = 1000;

  Serial.println();
}


void loop() {
  printValues();
  delay(delayTime);
}

void printValues() {
  Serial.print("Temp. Celsius  =    ");
  Serial.print(bme.readTemperature());
  Serial.println(" °C");

  //Convert temperature to Fahrenheit
  Serial.print("Temp.Fahrenheit =   ");
  Serial.print(1.8 * bme.readTemperature() + 32);
  Serial.println(" °F");

  Serial.print("Pressure =          ");
  Serial.print(bme.readPressure() / 100.0F);
  Serial.println(" hPa");

  Serial.print("Approx. Altitude =  ");
  Serial.print(bme.readAltitude(SEALEVELPRESSURE_HPA));
  Serial.println(" m");

  Serial.print("Humidity =          ");
  Serial.print(bme.readHumidity());
  Serial.println(" %");

  Serial.println();

  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.cp437(true);
  display.setCursor(15, 0);
  display.print("Weather station ");
  display.setCursor(4, 16);
  display.print("Temp. C: ");
  display.print(bme.readTemperature(), 2);
  display.print(" C");
  /*display.setCursor(4, 29);
  display.print("Temp. F: ");
  display.print(1.8 * bme.readTemperature() + 32);
  display.print(" F");*/

  display.setCursor(4, 29);
  display.print("Press.: ");
  display.print(bme.readPressure() / 100.0F);
  display.print(" hPA");

  display.setCursor(4, 42);
  display.print("Humid.: ");
  display.print(bme.readHumidity());
  display.print(" %");
  display.setCursor(4, 57);
  display.print("Altid.: ");
  display.print(bme.readAltitude(SEALEVELPRESSURE_HPA));
  display.print(" slm");


  display.display();
  delay(50);
  display.clearDisplay();
  delay(1000);
}
